#include <sys/types.h>
#include <sys/stat.h>
#include <sys/socket.h>
#include <unistd.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <dirent.h>
#include <fcntl.h>
#include <signal.h>
#include <errno.h>

#define PORT 4321
#define BUFSIZE 1024

#define T_XML	1
#define T_TJPG	2

int transmit_mode;
int fSFlag = 0;
struct stat st;
char * fileName;

void setDelay();

char* isFileExist();
int main(int argc, char **argv){
	int client_len;
	int client_sockfd;

	FILE *rfp;
//	char buf;
	char buf_get[BUFSIZE];
	char carNo[18];
//	int i = 0;
	//int flag = 0;

	struct sockaddr_in clientaddr;
	struct sigaction act;

	act.sa_handler = setDelay;
	if(sigfillset(&(act.sa_mask)) < 0)
		perror("sigfillset() fail:");
	act.sa_flags = 0;
	if (sigaction(SIGALRM, &act, 0) < 0)
		perror("sigaciotn() fail:");

	if ((rfp = fopen("CARINFO","r")) == NULL){
		printf("Error!!!\n");
		exit(1);
	}

	fread(carNo,1,17,rfp);
	carNo[17] = '\0';

	fclose(rfp);

	printf("%s: CARINFO Read complete\n",carNo);

	while(1){
		// File found
		printf("File Check!\n");
		if (isFileExist()){
			if ((rfp = fopen(fileName,"r")) == NULL){
				perror(">File Open Fail!:");
				continue;
			}
		}else{
			printf("> File Waiting!\n");
			sleep(10);
			continue;
		}
		client_sockfd = socket(AF_INET, SOCK_STREAM, 0);
		clientaddr.sin_family = AF_INET;
		clientaddr.sin_addr.s_addr = inet_addr("127.0.0.1");
		clientaddr.sin_port = htons(PORT);

		client_len = sizeof(clientaddr);

		if (connect(client_sockfd, (struct sockaddr *)&clientaddr, client_len) < 0)
		{
			perror("Connect error");
			sleep(10);
			continue;
		}
		printf("Connect Complete\n");
		//flag = 1;

		sprintf(buf_get,"SEND %s %ld %d\n",carNo,st.st_size, transmit_mode);

		if(write(client_sockfd,buf_get,BUFSIZE) == -1){
			perror("SEND Write Error");
			fclose(rfp);
			continue;
		}

		memset(buf_get,'\0',BUFSIZE);

		if(read(client_sockfd,buf_get,BUFSIZE) == -1){
			perror("ACCEPT READ Error");
			fclose(rfp);
			continue;
		}

		if (strcmp(buf_get,"ACCEPT\n")){
			perror("Not Accept");
			fclose(rfp);
			continue;
		}

		int sum = 0;
		int tmp = 0;


		memset(buf_get,'\0',BUFSIZE);

		while((tmp = fread(buf_get,1,BUFSIZE,rfp)) > 0)
		{

			if (write(client_sockfd, buf_get, tmp) == -1){
				perror("FILE Write Error");
				fclose(rfp);
				continue;
			}
			sum += tmp;
			memset(buf_get,'\0',BUFSIZE);
		}
		fclose(rfp);
		
		fsync(client_sockfd);

		printf("fclose Complete!\n");
		memset(buf_get,'\0',BUFSIZE);


		if (fcntl(client_sockfd, F_SETFL, O_NONBLOCK | FASYNC) < 0){
			perror("Non block Error\n");
			continue;
		}
		printf("Changing Non Block Mode\n");

		alarm(3);

		while(!fSFlag){;
			if(read(client_sockfd, buf_get,BUFSIZE) == -1){
				if (errno != EAGAIN)
					perror("Waiting Error");
				continue;
			}


			if(!strcmp(buf_get,"COMPLETE\n")){
				break;
			}else
				memset(buf_get,'\0',BUFSIZE);
		}
		alarm(0);
		printf("Waiting Flag = %d\n",fSFlag);

		if (fcntl(client_sockfd, F_SETFL, O_NDELAY) < 0){
			perror("block Error\n");
			continue;
		}
		printf("Changing Block Mode\n");

		if(!strcmp(buf_get,"COMPLETE\n")){
			char *name[3];
			int pid;
			name[0] = "rm";
			name[1] = fileName;
			name[2] = NULL;
			memset(buf_get,'\0',BUFSIZE);
			strcpy(buf_get,"OK\n");
			write(client_sockfd, buf_get, BUFSIZE);

			printf("FILE REMOVE!!!\n");
			pid = fork();
			if (pid != 0)
				wait(NULL);
			else{
				close(client_sockfd);
				if(execvp("rm",name) == -1){
					perror("REMOVE FAIL:");
				}
			}
		}
		printf("Ending\n");
		fSFlag = 0;
		close(client_sockfd);
		//flag = 0;
	}
	exit(0);
}

char* isFileExist(){
	struct dirent *d;
	DIR *dp;

	if ((dp = opendir("./log")) == NULL)
		return 0;

	while (d = readdir(dp)){
		if (d -> d_ino !=0 && 
				strcmp(d -> d_name,".") && 
				strcmp(d -> d_name,"..")){
			if (strstr(d -> d_name, "xml") == NULL && strstr(d -> d_name, "tjpg") == NULL )
				continue;

			if ( strstr(d -> d_name, "tjpg") != NULL )
				transmit_mode = T_TJPG;
			else
				transmit_mode = T_XML;

			if (fileName != NULL)
				free(fileName);
			fileName = (char *)malloc(sizeof(char) * (strlen(d -> d_name) + 7));
			sprintf(fileName,"./log/%s",d -> d_name);
			stat(fileName, &st);
			return d -> d_name;
		}
	}
	return NULL;
}

void setDelay(){
	fSFlag = 1;
	printf("%s\n","Delay!");
}
