#include "gps_parser.h"

using namespace std;

struct sockaddr_in clientaddr;

string parsing_data[6][20];

int parsing_cnt_table[] = {14,06,17,7,11,8,0};
int parsing_cnt[] ={0,0,0,0,0,0,0};

//extern pthread_mutex_t sec;
//extern pthread_cond_t sec_update;
extern pthread_mutex_t gps;
extern pthread_cond_t gps_update;
extern bool stop;
extern struct llpoint gps_buf;

void *gps_thread( void * arg ){
	// socket setting for GPS data
	int client_sockfd = connectGPS("127.0.0.1", GPSPORT);

	parsing_GPS_data_info(client_sockfd);

	// socket close
	close(client_sockfd);

	return NULL;
}

//  Connecting into GPS
int connectGPS(const char *ip,int port){
	int client_sockfd = socket(AF_INET, SOCK_STREAM, 0);
	clientaddr.sin_family = AF_INET;
	clientaddr.sin_addr.s_addr = inet_addr(ip);
	clientaddr.sin_port = htons(port);

	int client_len = sizeof(sockaddr_in);

	if (connect(client_sockfd, (struct sockaddr *)&clientaddr, client_len) == -1)  {
		perror("Connect error: ");
		exit(0);
	}
	return client_sockfd;
}

// send parsing GPS data
void parsing_send(string new_read_str){
	string parsing_str;
	string read_str;
	string nullstring = "0.0";
	double garbage;
	struct llpoint data;

	// translate string into input stream
	stringstream in(new_read_str);

	while(in >> parsing_str){
		int idx =0;

		if(parsing_str == "$GPGGA")
			idx = 0;
		else if(parsing_str == "$GPGLL")
			idx = 1;
		else if(parsing_str == "$GPGSA")
			idx = 2;
		else if(parsing_str == "$GPGSV")
			idx = 3;
		else if(parsing_str == "$GPRMC")
			idx = 4;
		else if(parsing_str == "$GPVTG")
			idx = 5;
		else idx = 6;

		// saving  GPS data about each instruction into parsing_data table
		for(;parsing_cnt[idx] < parsing_cnt_table[idx];){
			in >> parsing_str;

			if(parsing_str =="/") // "/" means null string
				parsing_data[idx][parsing_cnt[idx] % parsing_cnt_table[idx]] = nullstring;
			else parsing_data[idx][parsing_cnt[idx] % parsing_cnt_table[idx]] = parsing_str;
			parsing_cnt[idx]++;
		}

		if(idx != 6)
			parsing_cnt[idx] %= parsing_cnt_table[idx];

		if(idx == 5){
			// if instruction is $GPVTG, it starts translating data values into data structure 
			sscanf(parsing_data[0][0].c_str(),"%lf",&data.time);
			sscanf(parsing_data[0][1].c_str(),"%lf",&data.lat);
			sscanf(parsing_data[0][2].c_str(),"%c",&data.latNW);
			sscanf(parsing_data[0][3].c_str(),"%lf",&data.lon);
			sscanf(parsing_data[0][4].c_str(),"%c",&data.lonSE);

			// fix == 0 ; invalid     fix == 1; only gps    fix == 2; dgps
			sscanf(parsing_data[0][5].c_str(),"%d",&data.fix);

			sscanf(parsing_data[0][6].c_str(),"%lf",&data.numsats);
			sscanf(parsing_data[0][7].c_str(),"%lf",&data.hdop);
			sscanf(parsing_data[0][8].c_str(),"%lf",&data.sealv);
			sscanf(parsing_data[0][9].c_str(),"%c",&data.sealvM);
			sscanf(parsing_data[0][10].c_str(),"%lf",&data.height);
			sscanf(parsing_data[4][6].c_str(),"%lf",&data.speed);

			sscanf(parsing_data[0][13].c_str(),"%lf*%x",&garbage,&data.checksum);

			sscanf(parsing_data[4][1].c_str(),"%c",&data.valid);

			fprintf(stderr,"%.3lf %.3lf%c %.3lf%c %d %.3lf %.3lf %.3lf %c %.3lf %.3lf\n",
					data.time,data.lat,data.latNW,
					data.lon,data.lonSE,data.fix,data.numsats,data.hdop,
					data.sealv,data.sealvM,data.height,data.speed);

			/* copy frame to global buffer */
			pthread_mutex_lock( &gps );

			gps_buf = data;
			/* signal fresh_frame */
			pthread_cond_broadcast(&gps_update);
			pthread_mutex_unlock( &gps );

//			pthread_cond_broadcast(&sec_update);
		}
	}


}
void parsing_GPS_data_info(int client_sockfd){
	int i,len;
	int cntend = 0;
	string read_str = "";

	char message[BUFSIZE];

	while(!stop){
		read(client_sockfd, message, 1);
		len = 1;//strlen(message);
		message[1] = '\0';

		// gathering a set of GPS data
		read_str += message;

		// if end of message is '\n', it`s end of a set of GPS data. 
		if(message[len - 1] == '\n')
			cntend++;

		if(cntend < 2)
			continue;
		cntend = 0;

		string new_read_str = "";

		int len = read_str.size();

		// "," change " " and ",," change " / "
		// ex1)     , => ' '
		// ex2) 1,,,2 => 1 / / 2 

		for(i = 0; i < len; i++)
			if(read_str[i] ==','){
				if(read_str[i] == read_str[i+1])
					new_read_str += " / ";
				else 
					new_read_str += " ";
			}
			else
				new_read_str += read_str[i];

		// send parsing data
		parsing_send(new_read_str);

		read_str = "";
	}
}
